---
title: Styling IMSC documents
slug: Related/IMSC/Styling
tags:
  - Guide
  - IMSC
  - Styling
  - captions
  - subtitles
---
<div class="summary">
<p>IMSC offers many options for styling documents, and most of the IMSC styling properties have direct CSS equivalents, making them familiar to web developers.  In this guide you'll learn a bit more about IMSC styling including the difference between inline and referential styling, and efficient styling using inheritance and region styling.</p>
</div>

<h2 id="Inline_styling">Inline styling</h2>

<p>The simplest way of styling content elements like <code>&lt;p&gt;</code> or <code>&lt;span&gt;</code> is by specifying one or more style attributes, such as <code>tts:color</code>, on them. For instance, the following</p>

<pre class="brush: xml">&lt;p tts:textAlign="center"
   tts:fontSize="64px"
   tts:color="red"
   tts:fontFamily="proportionalSansSerif"
   tts:fontStyle="italic"&gt;
 Hello, I am Mork from Ork
&lt;/p&gt;</pre>

<p>yields:</p>

<p>{{EmbedGHLiveSample("imsc/inline-styles/inline-styles.html", '100%')}}</p>

<h2 id="Referential_styling">Referential styling</h2>

<p>Inline styling is usually avoided since it generates duplication.</p>

<p>Take for example the following two <code>&lt;span&gt;</code> elements, which have exactly the same style attributes:</p>

<pre class="brush: xml">&lt;p&gt;
  &lt;span tts:color="yellow" tts:backgroundColor="black"&gt;
   Hello, I am Mork from Ork.
  &lt;/span&gt;
&lt;/p&gt;
&lt;p&gt;
  &lt;span tts:color="yellow" tts:backgroundColor="black"&gt;
    I come from another planet.
  &lt;/span&gt;
&lt;/p&gt;
</pre>

<p>In referential styling, styles are defined once and reused throughout the document — in a similar way to how CSS rules can be declared once and then applied to multiple HTML elements via for example, element or class selectors. In IMSC this is achieved by defining a <code>&lt;styling&gt;</code> element inside the document <code>&lt;head&gt;</code>, inside which is placed one or more <code>&lt;style&gt;</code> elements — each one of which defines a set of styles that you can reuse elsewhere. This is illustrated below:</p>

<pre class="brush: xml">&lt;tt xmlns="http://www.w3.org/ns/ttml"
    xmlns:tts="http://www.w3.org/ns/ttml#styling"
    xml:lang="en"&gt;
  &lt;head&gt;
   &lt;styling&gt;
     &lt;style xml:id="s1" tts:color="yellow" tts:backgroundColor="black"/&gt;
   &lt;/styling&gt;
  &lt;/head&gt;
  &lt;body&gt;
    &lt;div&gt;
      &lt;p&gt;
        &lt;span style="s1"&gt;Hello, I am Mork from Ork.&lt;/span&gt;
      &lt;/p&gt;
      &lt;p&gt;
        &lt;span style="s1"&gt;I come from another planet.&lt;/span&gt;
      &lt;/p&gt;
    &lt;/div&gt;
  &lt;/body&gt;
  &lt;/tt&gt;
</pre>

<p>Each <code>&lt;style&gt;</code> element is given an <code>id</code> (<code>"s1"</code> in this example):</p>

<pre class="brush: xml">&lt;style xml:id="s1" tts:color="yellow" tts:backgroundColor="black"/&gt;</pre>

<p>which can then be referred to later in the document:</p>

<pre class="brush: xml">&lt;span style="s1"&gt;Hello, I am Mork from Ork.&lt;/span&gt;
</pre>

<p>this is equivalent to:</p>

<pre class="brush: xml">&lt;span tts:color="yellow" tts:backgroundColor="black"&gt;
  Hello, I am Mork from Ork
&lt;/span&gt;
</pre>

<p>In other words, referencing a <code>&lt;style&gt;</code> element via its <code>id</code> and the <code>style</code> attribute is equivalent to copying the style properties of the <code>&lt;style&gt;</code> element onto the referencing element, as if the style properties had been specified using inline styling.</p>

<h2 id="Style_inheritance">Style inheritance</h2>

<p>If a style property is inheritable, like <code>tts:color</code>, then the style property will apply to all the descendants of an element it is specified on — again, this is similar to CSS and HTML. In the following example, the color <code>"yellow"</code> is applied to the text of both <code>&lt;p&gt;</code> elements because they are descendants of the <code>&lt;body&gt;</code> element.</p>

<pre class="brush: xml">&lt;body tts:color="yellow"&gt;
  &lt;div&gt;
    &lt;p&gt;Hello, I am Mork from Ork.&lt;/p&gt;
    &lt;p&gt;I come from another planet.&lt;/p&gt;
  &lt;/div&gt;
&lt;/body&gt;
</pre>

<p>Specifying a style on an element overrides any style specified on an ancestor, for example in the following snippet, the color of the second <code>&lt;p&gt;</code>'s text would be set to <code>"aqua"</code>:</p>

<pre class="brush: xml">&lt;body tts:color="yellow"&gt;
  &lt;div&gt;
     &lt;p&gt;Hello, I am Mork from Ork.&lt;/p&gt;
     &lt;p tts:color="aqua"&gt;I come from another planet.&lt;/p&gt;
  &lt;/div&gt;
&lt;/body&gt;</pre>

<h2 id="Region_styling">Region styling</h2>

<p>Region styling plays a special role in IMSC since a style property specified on a region is inherited by all elements that are selected to the region, starting with the <code>&lt;body&gt;</code> element, as if the <code>&lt;region&gt;</code> element was the parent of the <code>&lt;body&gt; </code>element. For example, in the following example, the text "Hello, I am Mork from Ork" will appear in yellow.</p>

<pre class="brush: xml">&lt;tt
  xmlns="http://www.w3.org/ns/ttml"
  xmlns:tts="http://www.w3.org/ns/ttml#styling"
  xml:lang="en"&gt;
  &lt;head&gt;
    &lt;layout&gt;
      &lt;region xml:id="r1" tts:color="yellow" /&gt;
    &lt;/layout&gt;
 &lt;/head&gt;
 &lt;body&gt;
   &lt;div&gt;
     &lt;p region="r1"&gt;Hello, I am Mork from Ork&lt;/p&gt;
   &lt;/div&gt;
 &lt;/body&gt;
&lt;/tt&gt;</pre>

<h2 id="Combining_styles">Combining styles</h2>

<p>Referential styling can be applied to style elements themselves:</p>

<pre class="brush: xml">&lt;styling&gt;
  &lt;style xml:id="s1"
         tts:color="yellow"
         tts:backgroundColor="black"/&gt;
  &lt;style xml:id="s2"
         style="s1"
         tts:textAlign="left"/&gt;
&lt;/styling&gt;</pre>

<p>Multiple styles can be also applied simultaneously on an element. For example, in the snippet below the style properties of both styles <code>s1</code> and <code>s2</code> are applied to the same <code>&lt;p&gt;</code> element.</p>

<pre class="brush: xml">&lt;p style=”s1 s2”&gt;Hello, I am Mork from Ork&lt;/p&gt;</pre>

<section class="Quick_links" id="Quick_Links">
<ol>
 <li><a href="/en-US/docs/Related/IMSC/"><strong>IMSC</strong></a></li>
 <li class="toggle">
  <details open><summary>IMSC guides</summary>
  <ol>
   <li><a href="/en-US/docs/Related/IMSC/Basics">IMSC basics</a></li>
   <li><a href="/en-US/docs/Related/IMSC/Using_the_imscJS_polyfill">Using the imscJS polyfill</a></li>
   <li><a href="/en-US/docs/Related/IMSC/Styling">Styling IMSC documents</a></li>
   <li><a href="/en-US/docs/Related/IMSC/Subtitle_placement">Subtitle placement in IMSC</a></li>
   <li><a href="/en-US/docs/Related/IMSC/Namespaces">Namespaces in IMSC</a></li>
   <li><a href="/en-US/docs/Related/IMSC/Timing_in_IMSC">Timing in IMSC</a></li>
   <li><a href="/en-US/docs/Related/IMSC/Mapping_video_time_codes_to_IMSC">Mapping video time codes to IMSC</a></li>
   <li><a href="/en-US/docs/Related/IMSC/IMSC_and_other_standards">IMSC and other standards</a></li>
  </ol>
  </details>
 </li>
</ol>
</section>
